//+------------------------------------------------------------------+
//|                                             BB_CCI_CrossOver.mq4 |
//|                                            Copyright 2015, Vinin |
//|                                             http://vinin.ucoz.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Vinin"
#property link      "http://vinin.ucoz.ru"
#property version   "1.00"
#property strict
#property copyright "Daniel Vieira Costa"
#property link      "seilatrader.blogspot.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DarkTurquoise
#property indicator_color2 Red
//--
extern int    CCI_Periodo   = 21;
extern double NivelCCI_MIN  = -80;
extern double NivelCCI_MAX  = 80;
extern int    MM_Periodo    = 14;
extern int    BB_Periodo    = 21;
extern int    BB_Desvio     = 2;
extern double PIP_DesvioMAX = 0.0010;
extern double PIP_Oscilacao = 0.0015;
//---
double compra[];
double venda[];
//--
double CCI[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   IndicatorBuffers(3);
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 228);
   SetIndexBuffer(0, compra);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 230);
   SetIndexBuffer(1, venda);
   
   SetIndexBuffer(2, CCI);
//---- indicators
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   // indicadores
   double Range, AvgRange;
   double MM, BB_UP, BB_LOW;
   int limit1, limit2;

   limit1 = rates_total-prev_calculated;
   limit2=limit1;
   if (limit1>0)
   {
      limit1=rates_total-CCI_Periodo-1;
      limit2=limit1-MM_Periodo;
   }
   for (int i=limit1;i>=0;i--)
   {
      CCI[i]   = iCCI(NULL, 0, CCI_Periodo, PRICE_WEIGHTED, i);      
   }
   
   for (int i=limit2;i>=0;i--)
   
   {  
      Range    =0;
      AvgRange =iMA(NULL, 0, 10, 0, MODE_SMA, PRICE_HIGH,i)-iMA(NULL, 0, 10, 0, MODE_SMA, PRICE_LOW,i);
      
      MM    = iMAOnArray(CCI, 0, MM_Periodo, 0, MODE_EMA, i);
      BB_UP = iBands(NULL, 0, BB_Periodo, BB_Desvio, 0, PRICE_WEIGHTED, MODE_UPPER, i);    
      BB_LOW= iBands(NULL, 0, BB_Periodo, BB_Desvio, 0, PRICE_WEIGHTED, MODE_LOWER, i);
      // primeiro verifica se CCI est acima do nivel positivo
      if (CCI[i] > NivelCCI_MAX)
      {
         if (CCI[i] < MM)
            // verifica se o preo est dentro da banda superior
            if (High[i] <= BB_UP)
            {
               // verifica se a mxima  menor que a mxima anterior
               // o motivo  para ratificar a confirmao da tendncia
               if (High[i+1] > High[i])
                  // verifica a distncia entre a o preo mximo e a banda de bollinger
                  // s se posiciona se a distncia for considervel, ou seja, no to distante
                  if ((BB_UP -  High[i]) <= PIP_DesvioMAX)
                     venda[i] = High[i] + Range*0.10;
            }
            else
            // quando o preo est fora da banda superior
            if (High[i] >= BB_UP)
            {
               // verifica se a mxima  menor que a mxima anterior
               // o motivo  para ratificar a confirmao da tendncia
               if (High[i+1] > High[i])
                  venda[i] = High[i] + Range*0.10;
            }         
            
      }
      else
      // verifica se o nivel de CCI est abaixo da mnima
      if (CCI[i] < NivelCCI_MIN)
      {
         if (CCI[i] > MM)
            // quando o preo est dentro da banda inferior
            if (Low[i] >= BB_LOW)
            {
               // verifica se a mnima  maior que a mnima anterior
               // o motivo  para ratificar a confirmao da tendncia
               if (Low[i+1] < Low[i])
                  compra[i] = Low[i]- Range*0.10;
            }
            else
            // quando o preo ainda se encontra fora da banda inferior
            if (Low[i] <= BB_LOW)
            {
               if (Low[i+1] < Low[i])
                  compra[i] = Low[i]- Range*0.10;
            } 
      } 
   }
   return(0);
  }
//+------------------------------------------------------------------+